import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface EscalationPolicyConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/escalation_policy.html#description EscalationPolicy#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/escalation_policy.html#name EscalationPolicy#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/escalation_policy.html#num_loops EscalationPolicy#num_loops}.
     *
     * @stability stable
     */
    readonly numLoops?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/escalation_policy.html#teams EscalationPolicy#teams}.
     *
     * @stability stable
     */
    readonly teams?: string[];
    /**
     * rule block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/escalation_policy.html#rule EscalationPolicy#rule}
     *
     * @stability stable
     */
    readonly rule: EscalationPolicyRule[];
}
/**
 * @stability stable
 */
export interface EscalationPolicyRuleTarget {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/escalation_policy.html#id EscalationPolicy#id}.
     *
     * @stability stable
     */
    readonly id: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/escalation_policy.html#type EscalationPolicy#type}.
     *
     * @stability stable
     */
    readonly type?: string;
}
/**
 * @stability stable
 */
export interface EscalationPolicyRule {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/escalation_policy.html#escalation_delay_in_minutes EscalationPolicy#escalation_delay_in_minutes}.
     *
     * @stability stable
     */
    readonly escalationDelayInMinutes: number;
    /**
     * target block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/escalation_policy.html#target EscalationPolicy#target}
     *
     * @stability stable
     */
    readonly target: EscalationPolicyRuleTarget[];
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/pagerduty/r/escalation_policy.html pagerduty_escalation_policy}.
 *
 * @stability stable
 */
export declare class EscalationPolicy extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/pagerduty/r/escalation_policy.html pagerduty_escalation_policy} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: EscalationPolicyConfig);
    private _description?;
    /**
     * @stability stable
     */
    get description(): string | undefined;
    /**
     * @stability stable
     */
    set description(value: string | undefined);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _numLoops?;
    /**
     * @stability stable
     */
    get numLoops(): number | undefined;
    /**
     * @stability stable
     */
    set numLoops(value: number | undefined);
    /**
     * @stability stable
     */
    resetNumLoops(): void;
    /**
     * @stability stable
     */
    get numLoopsInput(): number | undefined;
    private _teams?;
    /**
     * @stability stable
     */
    get teams(): string[] | undefined;
    /**
     * @stability stable
     */
    set teams(value: string[] | undefined);
    /**
     * @stability stable
     */
    resetTeams(): void;
    /**
     * @stability stable
     */
    get teamsInput(): string[] | undefined;
    private _rule?;
    /**
     * @stability stable
     */
    get rule(): EscalationPolicyRule[];
    /**
     * @stability stable
     */
    set rule(value: EscalationPolicyRule[]);
    /**
     * @stability stable
     */
    get ruleInput(): EscalationPolicyRule[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
