import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface EventRuleConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/event_rule.html#action_json EventRule#action_json}.
     *
     * @stability stable
     */
    readonly actionJson: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/event_rule.html#advanced_condition_json EventRule#advanced_condition_json}.
     *
     * @stability stable
     */
    readonly advancedConditionJson?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/event_rule.html#condition_json EventRule#condition_json}.
     *
     * @stability stable
     */
    readonly conditionJson: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/pagerduty/r/event_rule.html pagerduty_event_rule}.
 *
 * @stability stable
 */
export declare class EventRule extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/pagerduty/r/event_rule.html pagerduty_event_rule} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: EventRuleConfig);
    private _actionJson?;
    /**
     * @stability stable
     */
    get actionJson(): string;
    /**
     * @stability stable
     */
    set actionJson(value: string);
    /**
     * @stability stable
     */
    get actionJsonInput(): string | undefined;
    private _advancedConditionJson?;
    /**
     * @stability stable
     */
    get advancedConditionJson(): string | undefined;
    /**
     * @stability stable
     */
    set advancedConditionJson(value: string | undefined);
    /**
     * @stability stable
     */
    resetAdvancedConditionJson(): void;
    /**
     * @stability stable
     */
    get advancedConditionJsonInput(): string | undefined;
    /**
     * @stability stable
     */
    get catchAll(): any;
    private _conditionJson?;
    /**
     * @stability stable
     */
    get conditionJson(): string;
    /**
     * @stability stable
     */
    set conditionJson(value: string);
    /**
     * @stability stable
     */
    get conditionJsonInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
