import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ExtensionServicenowConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/extension_servicenow.html#endpoint_url ExtensionServicenow#endpoint_url}.
     *
     * @stability stable
     */
    readonly endpointUrl?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/extension_servicenow.html#extension_objects ExtensionServicenow#extension_objects}.
     *
     * @stability stable
     */
    readonly extensionObjects: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/extension_servicenow.html#extension_schema ExtensionServicenow#extension_schema}.
     *
     * @stability stable
     */
    readonly extensionSchema: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/extension_servicenow.html#name ExtensionServicenow#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/extension_servicenow.html#referer ExtensionServicenow#referer}.
     *
     * @stability stable
     */
    readonly referer: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/extension_servicenow.html#snow_password ExtensionServicenow#snow_password}.
     *
     * @stability stable
     */
    readonly snowPassword: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/extension_servicenow.html#snow_user ExtensionServicenow#snow_user}.
     *
     * @stability stable
     */
    readonly snowUser: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/extension_servicenow.html#sync_options ExtensionServicenow#sync_options}.
     *
     * @stability stable
     */
    readonly syncOptions: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/extension_servicenow.html#target ExtensionServicenow#target}.
     *
     * @stability stable
     */
    readonly target: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/extension_servicenow.html#task_type ExtensionServicenow#task_type}.
     *
     * @stability stable
     */
    readonly taskType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/extension_servicenow.html#type ExtensionServicenow#type}.
     *
     * @stability stable
     */
    readonly type?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/pagerduty/r/extension_servicenow.html pagerduty_extension_servicenow}.
 *
 * @stability stable
 */
export declare class ExtensionServicenow extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/pagerduty/r/extension_servicenow.html pagerduty_extension_servicenow} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ExtensionServicenowConfig);
    private _endpointUrl?;
    /**
     * @stability stable
     */
    get endpointUrl(): string | undefined;
    /**
     * @stability stable
     */
    set endpointUrl(value: string | undefined);
    /**
     * @stability stable
     */
    resetEndpointUrl(): void;
    /**
     * @stability stable
     */
    get endpointUrlInput(): string | undefined;
    private _extensionObjects?;
    /**
     * @stability stable
     */
    get extensionObjects(): string[];
    /**
     * @stability stable
     */
    set extensionObjects(value: string[]);
    /**
     * @stability stable
     */
    get extensionObjectsInput(): string[] | undefined;
    private _extensionSchema?;
    /**
     * @stability stable
     */
    get extensionSchema(): string;
    /**
     * @stability stable
     */
    set extensionSchema(value: string);
    /**
     * @stability stable
     */
    get extensionSchemaInput(): string | undefined;
    /**
     * @stability stable
     */
    get htmlUrl(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string | undefined;
    /**
     * @stability stable
     */
    set name(value: string | undefined);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _referer?;
    /**
     * @stability stable
     */
    get referer(): string;
    /**
     * @stability stable
     */
    set referer(value: string);
    /**
     * @stability stable
     */
    get refererInput(): string | undefined;
    private _snowPassword?;
    /**
     * @stability stable
     */
    get snowPassword(): string;
    /**
     * @stability stable
     */
    set snowPassword(value: string);
    /**
     * @stability stable
     */
    get snowPasswordInput(): string | undefined;
    private _snowUser?;
    /**
     * @stability stable
     */
    get snowUser(): string;
    /**
     * @stability stable
     */
    set snowUser(value: string);
    /**
     * @stability stable
     */
    get snowUserInput(): string | undefined;
    private _syncOptions?;
    /**
     * @stability stable
     */
    get syncOptions(): string;
    /**
     * @stability stable
     */
    set syncOptions(value: string);
    /**
     * @stability stable
     */
    get syncOptionsInput(): string | undefined;
    private _target?;
    /**
     * @stability stable
     */
    get target(): string;
    /**
     * @stability stable
     */
    set target(value: string);
    /**
     * @stability stable
     */
    get targetInput(): string | undefined;
    private _taskType?;
    /**
     * @stability stable
     */
    get taskType(): string;
    /**
     * @stability stable
     */
    set taskType(value: string);
    /**
     * @stability stable
     */
    get taskTypeInput(): string | undefined;
    private _type?;
    /**
     * @stability stable
     */
    get type(): string | undefined;
    /**
     * @stability stable
     */
    set type(value: string | undefined);
    /**
     * @stability stable
     */
    resetType(): void;
    /**
     * @stability stable
     */
    get typeInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
