import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ResponsePlayConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/response_play.html#conference_number ResponsePlay#conference_number}.
     *
     * @stability stable
     */
    readonly conferenceNumber?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/response_play.html#conference_url ResponsePlay#conference_url}.
     *
     * @stability stable
     */
    readonly conferenceUrl?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/response_play.html#description ResponsePlay#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/response_play.html#from ResponsePlay#from}.
     *
     * @stability stable
     */
    readonly from: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/response_play.html#name ResponsePlay#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/response_play.html#responders_message ResponsePlay#responders_message}.
     *
     * @stability stable
     */
    readonly respondersMessage?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/response_play.html#runnability ResponsePlay#runnability}.
     *
     * @stability stable
     */
    readonly runnability?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/response_play.html#subscribers_message ResponsePlay#subscribers_message}.
     *
     * @stability stable
     */
    readonly subscribersMessage?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/response_play.html#team ResponsePlay#team}.
     *
     * @stability stable
     */
    readonly team?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/response_play.html#type ResponsePlay#type}.
     *
     * @stability stable
     */
    readonly type?: string;
    /**
     * responder block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/response_play.html#responder ResponsePlay#responder}
     *
     * @stability stable
     */
    readonly responder?: ResponsePlayResponder[];
    /**
     * subscriber block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/response_play.html#subscriber ResponsePlay#subscriber}
     *
     * @stability stable
     */
    readonly subscriber?: ResponsePlaySubscriber[];
}
/**
 * @stability stable
 */
export interface ResponsePlayResponder {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/response_play.html#description ResponsePlay#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/response_play.html#id ResponsePlay#id}.
     *
     * @stability stable
     */
    readonly id?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/response_play.html#name ResponsePlay#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/response_play.html#type ResponsePlay#type}.
     *
     * @stability stable
     */
    readonly type?: string;
}
/**
 * @stability stable
 */
export interface ResponsePlaySubscriber {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/response_play.html#id ResponsePlay#id}.
     *
     * @stability stable
     */
    readonly id?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/response_play.html#type ResponsePlay#type}.
     *
     * @stability stable
     */
    readonly type?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/pagerduty/r/response_play.html pagerduty_response_play}.
 *
 * @stability stable
 */
export declare class ResponsePlay extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/pagerduty/r/response_play.html pagerduty_response_play} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ResponsePlayConfig);
    private _conferenceNumber?;
    /**
     * @stability stable
     */
    get conferenceNumber(): string | undefined;
    /**
     * @stability stable
     */
    set conferenceNumber(value: string | undefined);
    /**
     * @stability stable
     */
    resetConferenceNumber(): void;
    /**
     * @stability stable
     */
    get conferenceNumberInput(): string | undefined;
    private _conferenceUrl?;
    /**
     * @stability stable
     */
    get conferenceUrl(): string | undefined;
    /**
     * @stability stable
     */
    set conferenceUrl(value: string | undefined);
    /**
     * @stability stable
     */
    resetConferenceUrl(): void;
    /**
     * @stability stable
     */
    get conferenceUrlInput(): string | undefined;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string | undefined;
    /**
     * @stability stable
     */
    set description(value: string | undefined);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _from?;
    /**
     * @stability stable
     */
    get from(): string;
    /**
     * @stability stable
     */
    set from(value: string);
    /**
     * @stability stable
     */
    get fromInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _respondersMessage?;
    /**
     * @stability stable
     */
    get respondersMessage(): string | undefined;
    /**
     * @stability stable
     */
    set respondersMessage(value: string | undefined);
    /**
     * @stability stable
     */
    resetRespondersMessage(): void;
    /**
     * @stability stable
     */
    get respondersMessageInput(): string | undefined;
    private _runnability?;
    /**
     * @stability stable
     */
    get runnability(): string | undefined;
    /**
     * @stability stable
     */
    set runnability(value: string | undefined);
    /**
     * @stability stable
     */
    resetRunnability(): void;
    /**
     * @stability stable
     */
    get runnabilityInput(): string | undefined;
    private _subscribersMessage?;
    /**
     * @stability stable
     */
    get subscribersMessage(): string | undefined;
    /**
     * @stability stable
     */
    set subscribersMessage(value: string | undefined);
    /**
     * @stability stable
     */
    resetSubscribersMessage(): void;
    /**
     * @stability stable
     */
    get subscribersMessageInput(): string | undefined;
    private _team?;
    /**
     * @stability stable
     */
    get team(): string | undefined;
    /**
     * @stability stable
     */
    set team(value: string | undefined);
    /**
     * @stability stable
     */
    resetTeam(): void;
    /**
     * @stability stable
     */
    get teamInput(): string | undefined;
    private _type?;
    /**
     * @stability stable
     */
    get type(): string | undefined;
    /**
     * @stability stable
     */
    set type(value: string | undefined);
    /**
     * @stability stable
     */
    resetType(): void;
    /**
     * @stability stable
     */
    get typeInput(): string | undefined;
    private _responder?;
    /**
     * @stability stable
     */
    get responder(): ResponsePlayResponder[] | undefined;
    /**
     * @stability stable
     */
    set responder(value: ResponsePlayResponder[] | undefined);
    /**
     * @stability stable
     */
    resetResponder(): void;
    /**
     * @stability stable
     */
    get responderInput(): ResponsePlayResponder[] | undefined;
    private _subscriber?;
    /**
     * @stability stable
     */
    get subscriber(): ResponsePlaySubscriber[] | undefined;
    /**
     * @stability stable
     */
    set subscriber(value: ResponsePlaySubscriber[] | undefined);
    /**
     * @stability stable
     */
    resetSubscriber(): void;
    /**
     * @stability stable
     */
    get subscriberInput(): ResponsePlaySubscriber[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
