import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface RulesetRuleConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#disabled RulesetRule#disabled}.
     *
     * @stability stable
     */
    readonly disabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#position RulesetRule#position}.
     *
     * @stability stable
     */
    readonly position?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#ruleset RulesetRule#ruleset}.
     *
     * @stability stable
     */
    readonly ruleset: string;
    /**
     * actions block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#actions RulesetRule#actions}
     *
     * @stability stable
     */
    readonly actions?: RulesetRuleActions;
    /**
     * conditions block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#conditions RulesetRule#conditions}
     *
     * @stability stable
     */
    readonly conditions?: RulesetRuleConditions;
    /**
     * time_frame block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#time_frame RulesetRule#time_frame}
     *
     * @stability stable
     */
    readonly timeFrame?: RulesetRuleTimeFrame;
    /**
     * variable block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#variable RulesetRule#variable}
     *
     * @stability stable
     */
    readonly variable?: RulesetRuleVariable[];
}
/**
 * @stability stable
 */
export interface RulesetRuleActionsAnnotate {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#value RulesetRule#value}.
     *
     * @stability stable
     */
    readonly value?: string;
}
/**
 * @stability stable
 */
export interface RulesetRuleActionsEventAction {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#value RulesetRule#value}.
     *
     * @stability stable
     */
    readonly value?: string;
}
/**
 * @stability stable
 */
export interface RulesetRuleActionsExtractions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#regex RulesetRule#regex}.
     *
     * @stability stable
     */
    readonly regex?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#source RulesetRule#source}.
     *
     * @stability stable
     */
    readonly source?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#target RulesetRule#target}.
     *
     * @stability stable
     */
    readonly target?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#template RulesetRule#template}.
     *
     * @stability stable
     */
    readonly template?: string;
}
/**
 * @stability stable
 */
export interface RulesetRuleActionsPriority {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#value RulesetRule#value}.
     *
     * @stability stable
     */
    readonly value?: string;
}
/**
 * @stability stable
 */
export interface RulesetRuleActionsRoute {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#value RulesetRule#value}.
     *
     * @stability stable
     */
    readonly value?: string;
}
/**
 * @stability stable
 */
export interface RulesetRuleActionsSeverity {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#value RulesetRule#value}.
     *
     * @stability stable
     */
    readonly value?: string;
}
/**
 * @stability stable
 */
export interface RulesetRuleActionsSuppress {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#threshold_time_amount RulesetRule#threshold_time_amount}.
     *
     * @stability stable
     */
    readonly thresholdTimeAmount?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#threshold_time_unit RulesetRule#threshold_time_unit}.
     *
     * @stability stable
     */
    readonly thresholdTimeUnit?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#threshold_value RulesetRule#threshold_value}.
     *
     * @stability stable
     */
    readonly thresholdValue?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#value RulesetRule#value}.
     *
     * @stability stable
     */
    readonly value?: boolean | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export interface RulesetRuleActionsSuspend {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#value RulesetRule#value}.
     *
     * @stability stable
     */
    readonly value?: number;
}
/**
 * @stability stable
 */
export interface RulesetRuleActions {
    /**
     * annotate block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#annotate RulesetRule#annotate}
     *
     * @stability stable
     */
    readonly annotate?: RulesetRuleActionsAnnotate[];
    /**
     * event_action block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#event_action RulesetRule#event_action}
     *
     * @stability stable
     */
    readonly eventAction?: RulesetRuleActionsEventAction[];
    /**
     * extractions block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#extractions RulesetRule#extractions}
     *
     * @stability stable
     */
    readonly extractions?: RulesetRuleActionsExtractions[];
    /**
     * priority block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#priority RulesetRule#priority}
     *
     * @stability stable
     */
    readonly priority?: RulesetRuleActionsPriority[];
    /**
     * route block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#route RulesetRule#route}
     *
     * @stability stable
     */
    readonly route?: RulesetRuleActionsRoute[];
    /**
     * severity block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#severity RulesetRule#severity}
     *
     * @stability stable
     */
    readonly severity?: RulesetRuleActionsSeverity[];
    /**
     * suppress block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#suppress RulesetRule#suppress}
     *
     * @stability stable
     */
    readonly suppress?: RulesetRuleActionsSuppress[];
    /**
     * suspend block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#suspend RulesetRule#suspend}
     *
     * @stability stable
     */
    readonly suspend?: RulesetRuleActionsSuspend[];
}
/**
 * @stability stable
 */
export declare class RulesetRuleActionsOutputReference extends cdktf.ComplexObject {
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    private _annotate?;
    /**
     * @stability stable
     */
    get annotate(): RulesetRuleActionsAnnotate[] | undefined;
    /**
     * @stability stable
     */
    set annotate(value: RulesetRuleActionsAnnotate[] | undefined);
    /**
     * @stability stable
     */
    resetAnnotate(): void;
    /**
     * @stability stable
     */
    get annotateInput(): RulesetRuleActionsAnnotate[] | undefined;
    private _eventAction?;
    /**
     * @stability stable
     */
    get eventAction(): RulesetRuleActionsEventAction[] | undefined;
    /**
     * @stability stable
     */
    set eventAction(value: RulesetRuleActionsEventAction[] | undefined);
    /**
     * @stability stable
     */
    resetEventAction(): void;
    /**
     * @stability stable
     */
    get eventActionInput(): RulesetRuleActionsEventAction[] | undefined;
    private _extractions?;
    /**
     * @stability stable
     */
    get extractions(): RulesetRuleActionsExtractions[] | undefined;
    /**
     * @stability stable
     */
    set extractions(value: RulesetRuleActionsExtractions[] | undefined);
    /**
     * @stability stable
     */
    resetExtractions(): void;
    /**
     * @stability stable
     */
    get extractionsInput(): RulesetRuleActionsExtractions[] | undefined;
    private _priority?;
    /**
     * @stability stable
     */
    get priority(): RulesetRuleActionsPriority[] | undefined;
    /**
     * @stability stable
     */
    set priority(value: RulesetRuleActionsPriority[] | undefined);
    /**
     * @stability stable
     */
    resetPriority(): void;
    /**
     * @stability stable
     */
    get priorityInput(): RulesetRuleActionsPriority[] | undefined;
    private _route?;
    /**
     * @stability stable
     */
    get route(): RulesetRuleActionsRoute[] | undefined;
    /**
     * @stability stable
     */
    set route(value: RulesetRuleActionsRoute[] | undefined);
    /**
     * @stability stable
     */
    resetRoute(): void;
    /**
     * @stability stable
     */
    get routeInput(): RulesetRuleActionsRoute[] | undefined;
    private _severity?;
    /**
     * @stability stable
     */
    get severity(): RulesetRuleActionsSeverity[] | undefined;
    /**
     * @stability stable
     */
    set severity(value: RulesetRuleActionsSeverity[] | undefined);
    /**
     * @stability stable
     */
    resetSeverity(): void;
    /**
     * @stability stable
     */
    get severityInput(): RulesetRuleActionsSeverity[] | undefined;
    private _suppress?;
    /**
     * @stability stable
     */
    get suppress(): RulesetRuleActionsSuppress[] | undefined;
    /**
     * @stability stable
     */
    set suppress(value: RulesetRuleActionsSuppress[] | undefined);
    /**
     * @stability stable
     */
    resetSuppress(): void;
    /**
     * @stability stable
     */
    get suppressInput(): RulesetRuleActionsSuppress[] | undefined;
    private _suspend?;
    /**
     * @stability stable
     */
    get suspend(): RulesetRuleActionsSuspend[] | undefined;
    /**
     * @stability stable
     */
    set suspend(value: RulesetRuleActionsSuspend[] | undefined);
    /**
     * @stability stable
     */
    resetSuspend(): void;
    /**
     * @stability stable
     */
    get suspendInput(): RulesetRuleActionsSuspend[] | undefined;
}
/**
 * @stability stable
 */
export interface RulesetRuleConditionsSubconditionsParameter {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#path RulesetRule#path}.
     *
     * @stability stable
     */
    readonly path?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#value RulesetRule#value}.
     *
     * @stability stable
     */
    readonly value?: string;
}
/**
 * @stability stable
 */
export interface RulesetRuleConditionsSubconditions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#operator RulesetRule#operator}.
     *
     * @stability stable
     */
    readonly operator?: string;
    /**
     * parameter block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#parameter RulesetRule#parameter}
     *
     * @stability stable
     */
    readonly parameter?: RulesetRuleConditionsSubconditionsParameter[];
}
/**
 * @stability stable
 */
export interface RulesetRuleConditions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#operator RulesetRule#operator}.
     *
     * @stability stable
     */
    readonly operator?: string;
    /**
     * subconditions block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#subconditions RulesetRule#subconditions}
     *
     * @stability stable
     */
    readonly subconditions?: RulesetRuleConditionsSubconditions[];
}
/**
 * @stability stable
 */
export declare class RulesetRuleConditionsOutputReference extends cdktf.ComplexObject {
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    private _operator?;
    /**
     * @stability stable
     */
    get operator(): string | undefined;
    /**
     * @stability stable
     */
    set operator(value: string | undefined);
    /**
     * @stability stable
     */
    resetOperator(): void;
    /**
     * @stability stable
     */
    get operatorInput(): string | undefined;
    private _subconditions?;
    /**
     * @stability stable
     */
    get subconditions(): RulesetRuleConditionsSubconditions[] | undefined;
    /**
     * @stability stable
     */
    set subconditions(value: RulesetRuleConditionsSubconditions[] | undefined);
    /**
     * @stability stable
     */
    resetSubconditions(): void;
    /**
     * @stability stable
     */
    get subconditionsInput(): RulesetRuleConditionsSubconditions[] | undefined;
}
/**
 * @stability stable
 */
export interface RulesetRuleTimeFrameActiveBetween {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#end_time RulesetRule#end_time}.
     *
     * @stability stable
     */
    readonly endTime?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#start_time RulesetRule#start_time}.
     *
     * @stability stable
     */
    readonly startTime?: number;
}
/**
 * @stability stable
 */
export interface RulesetRuleTimeFrameScheduledWeekly {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#duration RulesetRule#duration}.
     *
     * @stability stable
     */
    readonly duration?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#start_time RulesetRule#start_time}.
     *
     * @stability stable
     */
    readonly startTime?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#timezone RulesetRule#timezone}.
     *
     * @stability stable
     */
    readonly timezone?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#weekdays RulesetRule#weekdays}.
     *
     * @stability stable
     */
    readonly weekdays?: number[];
}
/**
 * @stability stable
 */
export interface RulesetRuleTimeFrame {
    /**
     * active_between block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#active_between RulesetRule#active_between}
     *
     * @stability stable
     */
    readonly activeBetween?: RulesetRuleTimeFrameActiveBetween[];
    /**
     * scheduled_weekly block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#scheduled_weekly RulesetRule#scheduled_weekly}
     *
     * @stability stable
     */
    readonly scheduledWeekly?: RulesetRuleTimeFrameScheduledWeekly[];
}
/**
 * @stability stable
 */
export declare class RulesetRuleTimeFrameOutputReference extends cdktf.ComplexObject {
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    private _activeBetween?;
    /**
     * @stability stable
     */
    get activeBetween(): RulesetRuleTimeFrameActiveBetween[] | undefined;
    /**
     * @stability stable
     */
    set activeBetween(value: RulesetRuleTimeFrameActiveBetween[] | undefined);
    /**
     * @stability stable
     */
    resetActiveBetween(): void;
    /**
     * @stability stable
     */
    get activeBetweenInput(): RulesetRuleTimeFrameActiveBetween[] | undefined;
    private _scheduledWeekly?;
    /**
     * @stability stable
     */
    get scheduledWeekly(): RulesetRuleTimeFrameScheduledWeekly[] | undefined;
    /**
     * @stability stable
     */
    set scheduledWeekly(value: RulesetRuleTimeFrameScheduledWeekly[] | undefined);
    /**
     * @stability stable
     */
    resetScheduledWeekly(): void;
    /**
     * @stability stable
     */
    get scheduledWeeklyInput(): RulesetRuleTimeFrameScheduledWeekly[] | undefined;
}
/**
 * @stability stable
 */
export interface RulesetRuleVariableParameters {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#path RulesetRule#path}.
     *
     * @stability stable
     */
    readonly path?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#value RulesetRule#value}.
     *
     * @stability stable
     */
    readonly value?: string;
}
/**
 * @stability stable
 */
export interface RulesetRuleVariable {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#name RulesetRule#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#type RulesetRule#type}.
     *
     * @stability stable
     */
    readonly type?: string;
    /**
     * parameters block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html#parameters RulesetRule#parameters}
     *
     * @stability stable
     */
    readonly parameters?: RulesetRuleVariableParameters[];
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html pagerduty_ruleset_rule}.
 *
 * @stability stable
 */
export declare class RulesetRule extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule.html pagerduty_ruleset_rule} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: RulesetRuleConfig);
    private _disabled?;
    /**
     * @stability stable
     */
    get disabled(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    set disabled(value: boolean | cdktf.IResolvable | undefined);
    /**
     * @stability stable
     */
    resetDisabled(): void;
    /**
     * @stability stable
     */
    get disabledInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _position?;
    /**
     * @stability stable
     */
    get position(): number | undefined;
    /**
     * @stability stable
     */
    set position(value: number | undefined);
    /**
     * @stability stable
     */
    resetPosition(): void;
    /**
     * @stability stable
     */
    get positionInput(): number | undefined;
    private _ruleset?;
    /**
     * @stability stable
     */
    get ruleset(): string;
    /**
     * @stability stable
     */
    set ruleset(value: string);
    /**
     * @stability stable
     */
    get rulesetInput(): string | undefined;
    private _actions?;
    private __actionsOutput;
    /**
     * @stability stable
     */
    get actions(): RulesetRuleActionsOutputReference;
    /**
     * @stability stable
     */
    putActions(value: RulesetRuleActions | undefined): void;
    /**
     * @stability stable
     */
    resetActions(): void;
    /**
     * @stability stable
     */
    get actionsInput(): RulesetRuleActions | undefined;
    private _conditions?;
    private __conditionsOutput;
    /**
     * @stability stable
     */
    get conditions(): RulesetRuleConditionsOutputReference;
    /**
     * @stability stable
     */
    putConditions(value: RulesetRuleConditions | undefined): void;
    /**
     * @stability stable
     */
    resetConditions(): void;
    /**
     * @stability stable
     */
    get conditionsInput(): RulesetRuleConditions | undefined;
    private _timeFrame?;
    private __timeFrameOutput;
    /**
     * @stability stable
     */
    get timeFrame(): RulesetRuleTimeFrameOutputReference;
    /**
     * @stability stable
     */
    putTimeFrame(value: RulesetRuleTimeFrame | undefined): void;
    /**
     * @stability stable
     */
    resetTimeFrame(): void;
    /**
     * @stability stable
     */
    get timeFrameInput(): RulesetRuleTimeFrame | undefined;
    private _variable?;
    /**
     * @stability stable
     */
    get variable(): RulesetRuleVariable[] | undefined;
    /**
     * @stability stable
     */
    set variable(value: RulesetRuleVariable[] | undefined);
    /**
     * @stability stable
     */
    resetVariable(): void;
    /**
     * @stability stable
     */
    get variableInput(): RulesetRuleVariable[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
