import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ServiceDependencyConfig extends cdktf.TerraformMetaArguments {
    /**
     * dependency block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_dependency.html#dependency ServiceDependency#dependency}
     *
     * @stability stable
     */
    readonly dependency: ServiceDependencyDependency[];
}
/**
 * @stability stable
 */
export interface ServiceDependencyDependencyDependentService {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_dependency.html#id ServiceDependency#id}.
     *
     * @stability stable
     */
    readonly id: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_dependency.html#type ServiceDependency#type}.
     *
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export interface ServiceDependencyDependencySupportingService {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_dependency.html#id ServiceDependency#id}.
     *
     * @stability stable
     */
    readonly id: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_dependency.html#type ServiceDependency#type}.
     *
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export interface ServiceDependencyDependency {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_dependency.html#type ServiceDependency#type}.
     *
     * @stability stable
     */
    readonly type?: string;
    /**
     * dependent_service block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_dependency.html#dependent_service ServiceDependency#dependent_service}
     *
     * @stability stable
     */
    readonly dependentService: ServiceDependencyDependencyDependentService[];
    /**
     * supporting_service block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_dependency.html#supporting_service ServiceDependency#supporting_service}
     *
     * @stability stable
     */
    readonly supportingService: ServiceDependencyDependencySupportingService[];
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/pagerduty/r/service_dependency.html pagerduty_service_dependency}.
 *
 * @stability stable
 */
export declare class ServiceDependency extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/pagerduty/r/service_dependency.html pagerduty_service_dependency} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ServiceDependencyConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _dependency?;
    /**
     * @stability stable
     */
    get dependency(): ServiceDependencyDependency[];
    /**
     * @stability stable
     */
    set dependency(value: ServiceDependencyDependency[]);
    /**
     * @stability stable
     */
    get dependencyInput(): ServiceDependencyDependency[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
