import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ServiceEventRuleConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#disabled ServiceEventRule#disabled}.
     *
     * @stability stable
     */
    readonly disabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#position ServiceEventRule#position}.
     *
     * @stability stable
     */
    readonly position?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#service ServiceEventRule#service}.
     *
     * @stability stable
     */
    readonly service: string;
    /**
     * actions block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#actions ServiceEventRule#actions}
     *
     * @stability stable
     */
    readonly actions?: ServiceEventRuleActions;
    /**
     * conditions block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#conditions ServiceEventRule#conditions}
     *
     * @stability stable
     */
    readonly conditions?: ServiceEventRuleConditions;
    /**
     * time_frame block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#time_frame ServiceEventRule#time_frame}
     *
     * @stability stable
     */
    readonly timeFrame?: ServiceEventRuleTimeFrame;
    /**
     * variable block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#variable ServiceEventRule#variable}
     *
     * @stability stable
     */
    readonly variable?: ServiceEventRuleVariable[];
}
/**
 * @stability stable
 */
export interface ServiceEventRuleActionsAnnotate {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#value ServiceEventRule#value}.
     *
     * @stability stable
     */
    readonly value?: string;
}
/**
 * @stability stable
 */
export interface ServiceEventRuleActionsEventAction {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#value ServiceEventRule#value}.
     *
     * @stability stable
     */
    readonly value?: string;
}
/**
 * @stability stable
 */
export interface ServiceEventRuleActionsExtractions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#regex ServiceEventRule#regex}.
     *
     * @stability stable
     */
    readonly regex?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#source ServiceEventRule#source}.
     *
     * @stability stable
     */
    readonly source?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#target ServiceEventRule#target}.
     *
     * @stability stable
     */
    readonly target?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#template ServiceEventRule#template}.
     *
     * @stability stable
     */
    readonly template?: string;
}
/**
 * @stability stable
 */
export interface ServiceEventRuleActionsPriority {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#value ServiceEventRule#value}.
     *
     * @stability stable
     */
    readonly value?: string;
}
/**
 * @stability stable
 */
export interface ServiceEventRuleActionsSeverity {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#value ServiceEventRule#value}.
     *
     * @stability stable
     */
    readonly value?: string;
}
/**
 * @stability stable
 */
export interface ServiceEventRuleActionsSuppress {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#threshold_time_amount ServiceEventRule#threshold_time_amount}.
     *
     * @stability stable
     */
    readonly thresholdTimeAmount?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#threshold_time_unit ServiceEventRule#threshold_time_unit}.
     *
     * @stability stable
     */
    readonly thresholdTimeUnit?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#threshold_value ServiceEventRule#threshold_value}.
     *
     * @stability stable
     */
    readonly thresholdValue?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#value ServiceEventRule#value}.
     *
     * @stability stable
     */
    readonly value?: boolean | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export interface ServiceEventRuleActionsSuspend {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#value ServiceEventRule#value}.
     *
     * @stability stable
     */
    readonly value?: number;
}
/**
 * @stability stable
 */
export interface ServiceEventRuleActions {
    /**
     * annotate block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#annotate ServiceEventRule#annotate}
     *
     * @stability stable
     */
    readonly annotate?: ServiceEventRuleActionsAnnotate[];
    /**
     * event_action block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#event_action ServiceEventRule#event_action}
     *
     * @stability stable
     */
    readonly eventAction?: ServiceEventRuleActionsEventAction[];
    /**
     * extractions block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#extractions ServiceEventRule#extractions}
     *
     * @stability stable
     */
    readonly extractions?: ServiceEventRuleActionsExtractions[];
    /**
     * priority block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#priority ServiceEventRule#priority}
     *
     * @stability stable
     */
    readonly priority?: ServiceEventRuleActionsPriority[];
    /**
     * severity block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#severity ServiceEventRule#severity}
     *
     * @stability stable
     */
    readonly severity?: ServiceEventRuleActionsSeverity[];
    /**
     * suppress block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#suppress ServiceEventRule#suppress}
     *
     * @stability stable
     */
    readonly suppress?: ServiceEventRuleActionsSuppress[];
    /**
     * suspend block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#suspend ServiceEventRule#suspend}
     *
     * @stability stable
     */
    readonly suspend?: ServiceEventRuleActionsSuspend[];
}
/**
 * @stability stable
 */
export declare class ServiceEventRuleActionsOutputReference extends cdktf.ComplexObject {
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    private _annotate?;
    /**
     * @stability stable
     */
    get annotate(): ServiceEventRuleActionsAnnotate[] | undefined;
    /**
     * @stability stable
     */
    set annotate(value: ServiceEventRuleActionsAnnotate[] | undefined);
    /**
     * @stability stable
     */
    resetAnnotate(): void;
    /**
     * @stability stable
     */
    get annotateInput(): ServiceEventRuleActionsAnnotate[] | undefined;
    private _eventAction?;
    /**
     * @stability stable
     */
    get eventAction(): ServiceEventRuleActionsEventAction[] | undefined;
    /**
     * @stability stable
     */
    set eventAction(value: ServiceEventRuleActionsEventAction[] | undefined);
    /**
     * @stability stable
     */
    resetEventAction(): void;
    /**
     * @stability stable
     */
    get eventActionInput(): ServiceEventRuleActionsEventAction[] | undefined;
    private _extractions?;
    /**
     * @stability stable
     */
    get extractions(): ServiceEventRuleActionsExtractions[] | undefined;
    /**
     * @stability stable
     */
    set extractions(value: ServiceEventRuleActionsExtractions[] | undefined);
    /**
     * @stability stable
     */
    resetExtractions(): void;
    /**
     * @stability stable
     */
    get extractionsInput(): ServiceEventRuleActionsExtractions[] | undefined;
    private _priority?;
    /**
     * @stability stable
     */
    get priority(): ServiceEventRuleActionsPriority[] | undefined;
    /**
     * @stability stable
     */
    set priority(value: ServiceEventRuleActionsPriority[] | undefined);
    /**
     * @stability stable
     */
    resetPriority(): void;
    /**
     * @stability stable
     */
    get priorityInput(): ServiceEventRuleActionsPriority[] | undefined;
    private _severity?;
    /**
     * @stability stable
     */
    get severity(): ServiceEventRuleActionsSeverity[] | undefined;
    /**
     * @stability stable
     */
    set severity(value: ServiceEventRuleActionsSeverity[] | undefined);
    /**
     * @stability stable
     */
    resetSeverity(): void;
    /**
     * @stability stable
     */
    get severityInput(): ServiceEventRuleActionsSeverity[] | undefined;
    private _suppress?;
    /**
     * @stability stable
     */
    get suppress(): ServiceEventRuleActionsSuppress[] | undefined;
    /**
     * @stability stable
     */
    set suppress(value: ServiceEventRuleActionsSuppress[] | undefined);
    /**
     * @stability stable
     */
    resetSuppress(): void;
    /**
     * @stability stable
     */
    get suppressInput(): ServiceEventRuleActionsSuppress[] | undefined;
    private _suspend?;
    /**
     * @stability stable
     */
    get suspend(): ServiceEventRuleActionsSuspend[] | undefined;
    /**
     * @stability stable
     */
    set suspend(value: ServiceEventRuleActionsSuspend[] | undefined);
    /**
     * @stability stable
     */
    resetSuspend(): void;
    /**
     * @stability stable
     */
    get suspendInput(): ServiceEventRuleActionsSuspend[] | undefined;
}
/**
 * @stability stable
 */
export interface ServiceEventRuleConditionsSubconditionsParameter {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#path ServiceEventRule#path}.
     *
     * @stability stable
     */
    readonly path?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#value ServiceEventRule#value}.
     *
     * @stability stable
     */
    readonly value?: string;
}
/**
 * @stability stable
 */
export interface ServiceEventRuleConditionsSubconditions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#operator ServiceEventRule#operator}.
     *
     * @stability stable
     */
    readonly operator?: string;
    /**
     * parameter block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#parameter ServiceEventRule#parameter}
     *
     * @stability stable
     */
    readonly parameter?: ServiceEventRuleConditionsSubconditionsParameter[];
}
/**
 * @stability stable
 */
export interface ServiceEventRuleConditions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#operator ServiceEventRule#operator}.
     *
     * @stability stable
     */
    readonly operator?: string;
    /**
     * subconditions block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#subconditions ServiceEventRule#subconditions}
     *
     * @stability stable
     */
    readonly subconditions?: ServiceEventRuleConditionsSubconditions[];
}
/**
 * @stability stable
 */
export declare class ServiceEventRuleConditionsOutputReference extends cdktf.ComplexObject {
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    private _operator?;
    /**
     * @stability stable
     */
    get operator(): string | undefined;
    /**
     * @stability stable
     */
    set operator(value: string | undefined);
    /**
     * @stability stable
     */
    resetOperator(): void;
    /**
     * @stability stable
     */
    get operatorInput(): string | undefined;
    private _subconditions?;
    /**
     * @stability stable
     */
    get subconditions(): ServiceEventRuleConditionsSubconditions[] | undefined;
    /**
     * @stability stable
     */
    set subconditions(value: ServiceEventRuleConditionsSubconditions[] | undefined);
    /**
     * @stability stable
     */
    resetSubconditions(): void;
    /**
     * @stability stable
     */
    get subconditionsInput(): ServiceEventRuleConditionsSubconditions[] | undefined;
}
/**
 * @stability stable
 */
export interface ServiceEventRuleTimeFrameActiveBetween {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#end_time ServiceEventRule#end_time}.
     *
     * @stability stable
     */
    readonly endTime?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#start_time ServiceEventRule#start_time}.
     *
     * @stability stable
     */
    readonly startTime?: number;
}
/**
 * @stability stable
 */
export interface ServiceEventRuleTimeFrameScheduledWeekly {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#duration ServiceEventRule#duration}.
     *
     * @stability stable
     */
    readonly duration?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#start_time ServiceEventRule#start_time}.
     *
     * @stability stable
     */
    readonly startTime?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#timezone ServiceEventRule#timezone}.
     *
     * @stability stable
     */
    readonly timezone?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#weekdays ServiceEventRule#weekdays}.
     *
     * @stability stable
     */
    readonly weekdays?: number[];
}
/**
 * @stability stable
 */
export interface ServiceEventRuleTimeFrame {
    /**
     * active_between block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#active_between ServiceEventRule#active_between}
     *
     * @stability stable
     */
    readonly activeBetween?: ServiceEventRuleTimeFrameActiveBetween[];
    /**
     * scheduled_weekly block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#scheduled_weekly ServiceEventRule#scheduled_weekly}
     *
     * @stability stable
     */
    readonly scheduledWeekly?: ServiceEventRuleTimeFrameScheduledWeekly[];
}
/**
 * @stability stable
 */
export declare class ServiceEventRuleTimeFrameOutputReference extends cdktf.ComplexObject {
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    private _activeBetween?;
    /**
     * @stability stable
     */
    get activeBetween(): ServiceEventRuleTimeFrameActiveBetween[] | undefined;
    /**
     * @stability stable
     */
    set activeBetween(value: ServiceEventRuleTimeFrameActiveBetween[] | undefined);
    /**
     * @stability stable
     */
    resetActiveBetween(): void;
    /**
     * @stability stable
     */
    get activeBetweenInput(): ServiceEventRuleTimeFrameActiveBetween[] | undefined;
    private _scheduledWeekly?;
    /**
     * @stability stable
     */
    get scheduledWeekly(): ServiceEventRuleTimeFrameScheduledWeekly[] | undefined;
    /**
     * @stability stable
     */
    set scheduledWeekly(value: ServiceEventRuleTimeFrameScheduledWeekly[] | undefined);
    /**
     * @stability stable
     */
    resetScheduledWeekly(): void;
    /**
     * @stability stable
     */
    get scheduledWeeklyInput(): ServiceEventRuleTimeFrameScheduledWeekly[] | undefined;
}
/**
 * @stability stable
 */
export interface ServiceEventRuleVariableParameters {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#path ServiceEventRule#path}.
     *
     * @stability stable
     */
    readonly path?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#value ServiceEventRule#value}.
     *
     * @stability stable
     */
    readonly value?: string;
}
/**
 * @stability stable
 */
export interface ServiceEventRuleVariable {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#name ServiceEventRule#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#type ServiceEventRule#type}.
     *
     * @stability stable
     */
    readonly type?: string;
    /**
     * parameters block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html#parameters ServiceEventRule#parameters}
     *
     * @stability stable
     */
    readonly parameters?: ServiceEventRuleVariableParameters[];
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html pagerduty_service_event_rule}.
 *
 * @stability stable
 */
export declare class ServiceEventRule extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule.html pagerduty_service_event_rule} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ServiceEventRuleConfig);
    private _disabled?;
    /**
     * @stability stable
     */
    get disabled(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    set disabled(value: boolean | cdktf.IResolvable | undefined);
    /**
     * @stability stable
     */
    resetDisabled(): void;
    /**
     * @stability stable
     */
    get disabledInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _position?;
    /**
     * @stability stable
     */
    get position(): number | undefined;
    /**
     * @stability stable
     */
    set position(value: number | undefined);
    /**
     * @stability stable
     */
    resetPosition(): void;
    /**
     * @stability stable
     */
    get positionInput(): number | undefined;
    private _service?;
    /**
     * @stability stable
     */
    get service(): string;
    /**
     * @stability stable
     */
    set service(value: string);
    /**
     * @stability stable
     */
    get serviceInput(): string | undefined;
    private _actions?;
    private __actionsOutput;
    /**
     * @stability stable
     */
    get actions(): ServiceEventRuleActionsOutputReference;
    /**
     * @stability stable
     */
    putActions(value: ServiceEventRuleActions | undefined): void;
    /**
     * @stability stable
     */
    resetActions(): void;
    /**
     * @stability stable
     */
    get actionsInput(): ServiceEventRuleActions | undefined;
    private _conditions?;
    private __conditionsOutput;
    /**
     * @stability stable
     */
    get conditions(): ServiceEventRuleConditionsOutputReference;
    /**
     * @stability stable
     */
    putConditions(value: ServiceEventRuleConditions | undefined): void;
    /**
     * @stability stable
     */
    resetConditions(): void;
    /**
     * @stability stable
     */
    get conditionsInput(): ServiceEventRuleConditions | undefined;
    private _timeFrame?;
    private __timeFrameOutput;
    /**
     * @stability stable
     */
    get timeFrame(): ServiceEventRuleTimeFrameOutputReference;
    /**
     * @stability stable
     */
    putTimeFrame(value: ServiceEventRuleTimeFrame | undefined): void;
    /**
     * @stability stable
     */
    resetTimeFrame(): void;
    /**
     * @stability stable
     */
    get timeFrameInput(): ServiceEventRuleTimeFrame | undefined;
    private _variable?;
    /**
     * @stability stable
     */
    get variable(): ServiceEventRuleVariable[] | undefined;
    /**
     * @stability stable
     */
    set variable(value: ServiceEventRuleVariable[] | undefined);
    /**
     * @stability stable
     */
    resetVariable(): void;
    /**
     * @stability stable
     */
    get variableInput(): ServiceEventRuleVariable[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
