import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ServiceConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#acknowledgement_timeout Service#acknowledgement_timeout}.
     *
     * @stability stable
     */
    readonly acknowledgementTimeout?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#alert_creation Service#alert_creation}.
     *
     * @stability stable
     */
    readonly alertCreation?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#alert_grouping Service#alert_grouping}.
     *
     * @stability stable
     */
    readonly alertGrouping?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#alert_grouping_timeout Service#alert_grouping_timeout}.
     *
     * @stability stable
     */
    readonly alertGroupingTimeout?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#auto_resolve_timeout Service#auto_resolve_timeout}.
     *
     * @stability stable
     */
    readonly autoResolveTimeout?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#description Service#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#escalation_policy Service#escalation_policy}.
     *
     * @stability stable
     */
    readonly escalationPolicy: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#name Service#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * alert_grouping_parameters block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#alert_grouping_parameters Service#alert_grouping_parameters}
     *
     * @stability stable
     */
    readonly alertGroupingParameters?: ServiceAlertGroupingParameters;
    /**
     * incident_urgency_rule block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#incident_urgency_rule Service#incident_urgency_rule}
     *
     * @stability stable
     */
    readonly incidentUrgencyRule?: ServiceIncidentUrgencyRule;
    /**
     * scheduled_actions block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#scheduled_actions Service#scheduled_actions}
     *
     * @stability stable
     */
    readonly scheduledActions?: ServiceScheduledActions[];
    /**
     * support_hours block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#support_hours Service#support_hours}
     *
     * @stability stable
     */
    readonly supportHours?: ServiceSupportHours;
}
/**
 * @stability stable
 */
export interface ServiceAlertGroupingParametersConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#aggregate Service#aggregate}.
     *
     * @stability stable
     */
    readonly aggregate?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#fields Service#fields}.
     *
     * @stability stable
     */
    readonly fields?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#timeout Service#timeout}.
     *
     * @stability stable
     */
    readonly timeout?: number;
}
/**
 * @stability stable
 */
export declare class ServiceAlertGroupingParametersConfigOutputReference extends cdktf.ComplexObject {
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    private _aggregate?;
    /**
     * @stability stable
     */
    get aggregate(): string | undefined;
    /**
     * @stability stable
     */
    set aggregate(value: string | undefined);
    /**
     * @stability stable
     */
    resetAggregate(): void;
    /**
     * @stability stable
     */
    get aggregateInput(): string | undefined;
    private _fields?;
    /**
     * @stability stable
     */
    get fields(): string[] | undefined;
    /**
     * @stability stable
     */
    set fields(value: string[] | undefined);
    /**
     * @stability stable
     */
    resetFields(): void;
    /**
     * @stability stable
     */
    get fieldsInput(): string[] | undefined;
    private _timeout?;
    /**
     * @stability stable
     */
    get timeout(): number | undefined;
    /**
     * @stability stable
     */
    set timeout(value: number | undefined);
    /**
     * @stability stable
     */
    resetTimeout(): void;
    /**
     * @stability stable
     */
    get timeoutInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface ServiceAlertGroupingParameters {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#type Service#type}.
     *
     * @stability stable
     */
    readonly type?: string;
    /**
     * config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#config Service#config}
     *
     * @stability stable
     */
    readonly config?: ServiceAlertGroupingParametersConfig;
}
/**
 * @stability stable
 */
export declare class ServiceAlertGroupingParametersOutputReference extends cdktf.ComplexObject {
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    private _type?;
    /**
     * @stability stable
     */
    get type(): string | undefined;
    /**
     * @stability stable
     */
    set type(value: string | undefined);
    /**
     * @stability stable
     */
    resetType(): void;
    /**
     * @stability stable
     */
    get typeInput(): string | undefined;
    private _config?;
    private __configOutput;
    /**
     * @stability stable
     */
    get config(): ServiceAlertGroupingParametersConfigOutputReference;
    /**
     * @stability stable
     */
    putConfig(value: ServiceAlertGroupingParametersConfig | undefined): void;
    /**
     * @stability stable
     */
    resetConfig(): void;
    /**
     * @stability stable
     */
    get configInput(): ServiceAlertGroupingParametersConfig | undefined;
}
/**
 * @stability stable
 */
export interface ServiceIncidentUrgencyRuleDuringSupportHours {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#type Service#type}.
     *
     * @stability stable
     */
    readonly type?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#urgency Service#urgency}.
     *
     * @stability stable
     */
    readonly urgency?: string;
}
/**
 * @stability stable
 */
export declare class ServiceIncidentUrgencyRuleDuringSupportHoursOutputReference extends cdktf.ComplexObject {
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    private _type?;
    /**
     * @stability stable
     */
    get type(): string | undefined;
    /**
     * @stability stable
     */
    set type(value: string | undefined);
    /**
     * @stability stable
     */
    resetType(): void;
    /**
     * @stability stable
     */
    get typeInput(): string | undefined;
    private _urgency?;
    /**
     * @stability stable
     */
    get urgency(): string | undefined;
    /**
     * @stability stable
     */
    set urgency(value: string | undefined);
    /**
     * @stability stable
     */
    resetUrgency(): void;
    /**
     * @stability stable
     */
    get urgencyInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface ServiceIncidentUrgencyRuleOutsideSupportHours {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#type Service#type}.
     *
     * @stability stable
     */
    readonly type?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#urgency Service#urgency}.
     *
     * @stability stable
     */
    readonly urgency?: string;
}
/**
 * @stability stable
 */
export declare class ServiceIncidentUrgencyRuleOutsideSupportHoursOutputReference extends cdktf.ComplexObject {
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    private _type?;
    /**
     * @stability stable
     */
    get type(): string | undefined;
    /**
     * @stability stable
     */
    set type(value: string | undefined);
    /**
     * @stability stable
     */
    resetType(): void;
    /**
     * @stability stable
     */
    get typeInput(): string | undefined;
    private _urgency?;
    /**
     * @stability stable
     */
    get urgency(): string | undefined;
    /**
     * @stability stable
     */
    set urgency(value: string | undefined);
    /**
     * @stability stable
     */
    resetUrgency(): void;
    /**
     * @stability stable
     */
    get urgencyInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface ServiceIncidentUrgencyRule {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#type Service#type}.
     *
     * @stability stable
     */
    readonly type: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#urgency Service#urgency}.
     *
     * @stability stable
     */
    readonly urgency?: string;
    /**
     * during_support_hours block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#during_support_hours Service#during_support_hours}
     *
     * @stability stable
     */
    readonly duringSupportHours?: ServiceIncidentUrgencyRuleDuringSupportHours;
    /**
     * outside_support_hours block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#outside_support_hours Service#outside_support_hours}
     *
     * @stability stable
     */
    readonly outsideSupportHours?: ServiceIncidentUrgencyRuleOutsideSupportHours;
}
/**
 * @stability stable
 */
export declare class ServiceIncidentUrgencyRuleOutputReference extends cdktf.ComplexObject {
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    private _type?;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    set type(value: string);
    /**
     * @stability stable
     */
    get typeInput(): string | undefined;
    private _urgency?;
    /**
     * @stability stable
     */
    get urgency(): string | undefined;
    /**
     * @stability stable
     */
    set urgency(value: string | undefined);
    /**
     * @stability stable
     */
    resetUrgency(): void;
    /**
     * @stability stable
     */
    get urgencyInput(): string | undefined;
    private _duringSupportHours?;
    private __duringSupportHoursOutput;
    /**
     * @stability stable
     */
    get duringSupportHours(): ServiceIncidentUrgencyRuleDuringSupportHoursOutputReference;
    /**
     * @stability stable
     */
    putDuringSupportHours(value: ServiceIncidentUrgencyRuleDuringSupportHours | undefined): void;
    /**
     * @stability stable
     */
    resetDuringSupportHours(): void;
    /**
     * @stability stable
     */
    get duringSupportHoursInput(): ServiceIncidentUrgencyRuleDuringSupportHours | undefined;
    private _outsideSupportHours?;
    private __outsideSupportHoursOutput;
    /**
     * @stability stable
     */
    get outsideSupportHours(): ServiceIncidentUrgencyRuleOutsideSupportHoursOutputReference;
    /**
     * @stability stable
     */
    putOutsideSupportHours(value: ServiceIncidentUrgencyRuleOutsideSupportHours | undefined): void;
    /**
     * @stability stable
     */
    resetOutsideSupportHours(): void;
    /**
     * @stability stable
     */
    get outsideSupportHoursInput(): ServiceIncidentUrgencyRuleOutsideSupportHours | undefined;
}
/**
 * @stability stable
 */
export interface ServiceScheduledActionsAt {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#name Service#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#type Service#type}.
     *
     * @stability stable
     */
    readonly type?: string;
}
/**
 * @stability stable
 */
export interface ServiceScheduledActions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#to_urgency Service#to_urgency}.
     *
     * @stability stable
     */
    readonly toUrgency?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#type Service#type}.
     *
     * @stability stable
     */
    readonly type?: string;
    /**
     * at block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#at Service#at}
     *
     * @stability stable
     */
    readonly at?: ServiceScheduledActionsAt[];
}
/**
 * @stability stable
 */
export interface ServiceSupportHours {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#days_of_week Service#days_of_week}.
     *
     * @stability stable
     */
    readonly daysOfWeek?: number[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#end_time Service#end_time}.
     *
     * @stability stable
     */
    readonly endTime?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#start_time Service#start_time}.
     *
     * @stability stable
     */
    readonly startTime?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#time_zone Service#time_zone}.
     *
     * @stability stable
     */
    readonly timeZone?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#type Service#type}.
     *
     * @stability stable
     */
    readonly type?: string;
}
/**
 * @stability stable
 */
export declare class ServiceSupportHoursOutputReference extends cdktf.ComplexObject {
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    private _daysOfWeek?;
    /**
     * @stability stable
     */
    get daysOfWeek(): number[] | undefined;
    /**
     * @stability stable
     */
    set daysOfWeek(value: number[] | undefined);
    /**
     * @stability stable
     */
    resetDaysOfWeek(): void;
    /**
     * @stability stable
     */
    get daysOfWeekInput(): number[] | undefined;
    private _endTime?;
    /**
     * @stability stable
     */
    get endTime(): string | undefined;
    /**
     * @stability stable
     */
    set endTime(value: string | undefined);
    /**
     * @stability stable
     */
    resetEndTime(): void;
    /**
     * @stability stable
     */
    get endTimeInput(): string | undefined;
    private _startTime?;
    /**
     * @stability stable
     */
    get startTime(): string | undefined;
    /**
     * @stability stable
     */
    set startTime(value: string | undefined);
    /**
     * @stability stable
     */
    resetStartTime(): void;
    /**
     * @stability stable
     */
    get startTimeInput(): string | undefined;
    private _timeZone?;
    /**
     * @stability stable
     */
    get timeZone(): string | undefined;
    /**
     * @stability stable
     */
    set timeZone(value: string | undefined);
    /**
     * @stability stable
     */
    resetTimeZone(): void;
    /**
     * @stability stable
     */
    get timeZoneInput(): string | undefined;
    private _type?;
    /**
     * @stability stable
     */
    get type(): string | undefined;
    /**
     * @stability stable
     */
    set type(value: string | undefined);
    /**
     * @stability stable
     */
    resetType(): void;
    /**
     * @stability stable
     */
    get typeInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html pagerduty_service}.
 *
 * @stability stable
 */
export declare class Service extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html pagerduty_service} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ServiceConfig);
    private _acknowledgementTimeout?;
    /**
     * @stability stable
     */
    get acknowledgementTimeout(): string | undefined;
    /**
     * @stability stable
     */
    set acknowledgementTimeout(value: string | undefined);
    /**
     * @stability stable
     */
    resetAcknowledgementTimeout(): void;
    /**
     * @stability stable
     */
    get acknowledgementTimeoutInput(): string | undefined;
    private _alertCreation?;
    /**
     * @stability stable
     */
    get alertCreation(): string | undefined;
    /**
     * @stability stable
     */
    set alertCreation(value: string | undefined);
    /**
     * @stability stable
     */
    resetAlertCreation(): void;
    /**
     * @stability stable
     */
    get alertCreationInput(): string | undefined;
    private _alertGrouping?;
    /**
     * @stability stable
     */
    get alertGrouping(): string | undefined;
    /**
     * @stability stable
     */
    set alertGrouping(value: string | undefined);
    /**
     * @stability stable
     */
    resetAlertGrouping(): void;
    /**
     * @stability stable
     */
    get alertGroupingInput(): string | undefined;
    private _alertGroupingTimeout?;
    /**
     * @stability stable
     */
    get alertGroupingTimeout(): number | undefined;
    /**
     * @stability stable
     */
    set alertGroupingTimeout(value: number | undefined);
    /**
     * @stability stable
     */
    resetAlertGroupingTimeout(): void;
    /**
     * @stability stable
     */
    get alertGroupingTimeoutInput(): number | undefined;
    private _autoResolveTimeout?;
    /**
     * @stability stable
     */
    get autoResolveTimeout(): string | undefined;
    /**
     * @stability stable
     */
    set autoResolveTimeout(value: string | undefined);
    /**
     * @stability stable
     */
    resetAutoResolveTimeout(): void;
    /**
     * @stability stable
     */
    get autoResolveTimeoutInput(): string | undefined;
    /**
     * @stability stable
     */
    get createdAt(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string | undefined;
    /**
     * @stability stable
     */
    set description(value: string | undefined);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _escalationPolicy?;
    /**
     * @stability stable
     */
    get escalationPolicy(): string;
    /**
     * @stability stable
     */
    set escalationPolicy(value: string);
    /**
     * @stability stable
     */
    get escalationPolicyInput(): string | undefined;
    /**
     * @stability stable
     */
    get htmlUrl(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get lastIncidentTimestamp(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    /**
     * @stability stable
     */
    get status(): string;
    private _alertGroupingParameters?;
    private __alertGroupingParametersOutput;
    /**
     * @stability stable
     */
    get alertGroupingParameters(): ServiceAlertGroupingParametersOutputReference;
    /**
     * @stability stable
     */
    putAlertGroupingParameters(value: ServiceAlertGroupingParameters | undefined): void;
    /**
     * @stability stable
     */
    resetAlertGroupingParameters(): void;
    /**
     * @stability stable
     */
    get alertGroupingParametersInput(): ServiceAlertGroupingParameters | undefined;
    private _incidentUrgencyRule?;
    private __incidentUrgencyRuleOutput;
    /**
     * @stability stable
     */
    get incidentUrgencyRule(): ServiceIncidentUrgencyRuleOutputReference;
    /**
     * @stability stable
     */
    putIncidentUrgencyRule(value: ServiceIncidentUrgencyRule | undefined): void;
    /**
     * @stability stable
     */
    resetIncidentUrgencyRule(): void;
    /**
     * @stability stable
     */
    get incidentUrgencyRuleInput(): ServiceIncidentUrgencyRule | undefined;
    private _scheduledActions?;
    /**
     * @stability stable
     */
    get scheduledActions(): ServiceScheduledActions[] | undefined;
    /**
     * @stability stable
     */
    set scheduledActions(value: ServiceScheduledActions[] | undefined);
    /**
     * @stability stable
     */
    resetScheduledActions(): void;
    /**
     * @stability stable
     */
    get scheduledActionsInput(): ServiceScheduledActions[] | undefined;
    private _supportHours?;
    private __supportHoursOutput;
    /**
     * @stability stable
     */
    get supportHours(): ServiceSupportHoursOutputReference;
    /**
     * @stability stable
     */
    putSupportHours(value: ServiceSupportHours | undefined): void;
    /**
     * @stability stable
     */
    resetSupportHours(): void;
    /**
     * @stability stable
     */
    get supportHoursInput(): ServiceSupportHours | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
