import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SlackConnectionConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/slack_connection.html#channel_id SlackConnection#channel_id}.
     *
     * @stability stable
     */
    readonly channelId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/slack_connection.html#notification_type SlackConnection#notification_type}.
     *
     * @stability stable
     */
    readonly notificationType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/slack_connection.html#source_id SlackConnection#source_id}.
     *
     * @stability stable
     */
    readonly sourceId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/slack_connection.html#source_type SlackConnection#source_type}.
     *
     * @stability stable
     */
    readonly sourceType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/slack_connection.html#workspace_id SlackConnection#workspace_id}.
     *
     * @stability stable
     */
    readonly workspaceId: string;
    /**
     * config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/slack_connection.html#config SlackConnection#config}
     *
     * @stability stable
     */
    readonly config: SlackConnectionConfigA[];
}
/**
 * @stability stable
 */
export interface SlackConnectionConfigA {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/slack_connection.html#events SlackConnection#events}.
     *
     * @stability stable
     */
    readonly events: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/slack_connection.html#priorities SlackConnection#priorities}.
     *
     * @stability stable
     */
    readonly priorities?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/slack_connection.html#urgency SlackConnection#urgency}.
     *
     * @stability stable
     */
    readonly urgency?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/pagerduty/r/slack_connection.html pagerduty_slack_connection}.
 *
 * @stability stable
 */
export declare class SlackConnection extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/pagerduty/r/slack_connection.html pagerduty_slack_connection} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SlackConnectionConfig);
    private _channelId?;
    /**
     * @stability stable
     */
    get channelId(): string;
    /**
     * @stability stable
     */
    set channelId(value: string);
    /**
     * @stability stable
     */
    get channelIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get channelName(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _notificationType?;
    /**
     * @stability stable
     */
    get notificationType(): string;
    /**
     * @stability stable
     */
    set notificationType(value: string);
    /**
     * @stability stable
     */
    get notificationTypeInput(): string | undefined;
    private _sourceId?;
    /**
     * @stability stable
     */
    get sourceId(): string;
    /**
     * @stability stable
     */
    set sourceId(value: string);
    /**
     * @stability stable
     */
    get sourceIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get sourceName(): string;
    private _sourceType?;
    /**
     * @stability stable
     */
    get sourceType(): string;
    /**
     * @stability stable
     */
    set sourceType(value: string);
    /**
     * @stability stable
     */
    get sourceTypeInput(): string | undefined;
    private _workspaceId?;
    /**
     * @stability stable
     */
    get workspaceId(): string;
    /**
     * @stability stable
     */
    set workspaceId(value: string);
    /**
     * @stability stable
     */
    get workspaceIdInput(): string | undefined;
    private _config?;
    /**
     * @stability stable
     */
    get config(): SlackConnectionConfigA[];
    /**
     * @stability stable
     */
    set config(value: SlackConnectionConfigA[]);
    /**
     * @stability stable
     */
    get configInput(): SlackConnectionConfigA[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
